=== debian/changelog ===
rocprim (5.5.1-1) unstable; urgency=medium

  * New upstream version 5.5.1
  * d/rules: drop gfx1011 from librocprim-tests

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 28 Jul 2023 21:58:33 -0600

rocprim (5.3.3-6) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 12 Jul 2023 15:15:55 -0600

rocprim (5.3.3-6~exp1) experimental; urgency=medium

  * Add librocprim-tests package for autopkgtests.
  * d/rules: explicitly disable lto

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 06 Jul 2023 00:37:30 -0600

rocprim (5.3.3-5) unstable; urgency=medium

  * Reintroduce the changes we temporarily reverted for bookworm, these being:
    - d/control: library is arch-independent
    - move cmake files to /usr/share
  * Add myself to Uploaders
  * Fix Maintainer name

 -- Christian Kastner <ckk@debian.org>  Sun, 11 Jun 2023 15:35:33 +0200
