## rocprim 5.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -75,7 +75,7 @@
 
   if(GPU_TARGETS STREQUAL "all")
     rocm_check_target_ids(DEFAULT_AMDGPU_TARGETS
-      TARGETS "gfx803;gfx900:xnack-;gfx906:xnack-;gfx908:xnack-;gfx90a:xnack-;gfx90a:xnack+;gfx1030;gfx1100;gfx1101;gfx1102"
+      TARGETS "gfx803;gfx900:xnack-;gfx906:xnack-;gfx908:xnack-;gfx90a:xnack-;gfx90a:xnack+;gfx940;gfx941;gfx942;gfx1030;gfx1100;gfx1101;gfx1102"
     )
     set(GPU_TARGETS "${DEFAULT_AMDGPU_TARGETS}" CACHE STRING "GPU architectures to compile for" FORCE)
   endif()
@@ -110,7 +110,7 @@
 endif()
 
 # Setup VERSION
-set(VERSION_STRING "2.10.9")
+set(VERSION_STRING "2.13.1")
 rocm_setup_version(VERSION ${VERSION_STRING})
 
 # Print configuration summary
