=== debian/changelog ===
rocprim (5.7.1-2) unstable; urgency=medium

  * Migrate to unstable
  * Add d/p/test-warp-sort-ppc64el.patch to drop test_warp_sort from
    librocprim-tests on ppc64el due to FTBFS when compiling with clang-17.
    This is a workaround for bug #1065206
  * Add d/p/verbose-build.patch to print more log messages during the build,
    to prevent timeouts on slower buildd systems.

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 25 Mar 2024 15:17:12 -0600

rocprim (5.7.1-2~exp2) experimental; urgency=medium

  * Add d/p/arch-conversion-macro.patch to support loading gfx900 code objects
    on gfx902, gfx909, and gfx90c, as well as gfx1030 code objects on gfx1031
    to gfx1036.
  * Add d/gbp.conf to ensure consistent settings

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 25 Mar 2024 02:44:48 -0600

rocprim (5.7.1-2~exp1) experimental; urgency=medium

  * Enable gfx1100, gfx1101, and gfx1102 architectures
  * Update Build-Depends to require clang-17
  * Drop patchelf from Build-Depends
  * d/rules: mark test packages as <!nocheck>

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 29 Feb 2024 13:06:02 -0700

rocprim (5.7.1-1) unstable; urgency=medium

  * Migrate to unstable
  * Update upstream URLs

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 25 Jan 2024 12:58:03 -0700

rocprim (5.7.1-1~exp1) experimental; urgency=medium

  * New upstream version 5.7.1
  * dbgsym: Disable dwz and switch to compressed DWARF-5

 -- Christian Kastner <ckk@debian.org>  Fri, 27 Oct 2023 12:31:25 +0200

rocprim (5.5.1-2) unstable; urgency=medium

  * Filter cf-protection hardening from device code.
    Fixes a FTBFS with dpkg >= 1.22

 -- Christian Kastner <ckk@debian.org>  Thu, 14 Sep 2023 14:16:14 +0200
