=== debian/rules ===
--- 
+++ 
@@ -1,17 +1,19 @@
 #!/usr/bin/make -f
 export CXX=hipcc
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
-export DEB_CXXFLAGS_MAINT_PREPEND = -gdwarf-4
+export DEB_CXXFLAGS_MAINT_PREPEND = -gz -DROCPRIM_USE_ARCH_CONVERSION
 export VERBOSE=1
 #export AMD_LOG_LEVEL=4
 
 # filter incompatible options from affecting device code
 CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
+CXXFLAGS := $(subst -fcf-protection,-Xarch_host -fcf-protection,$(CXXFLAGS))
 
 CMAKE_FLAGS = \
 	-DCMAKE_BUILD_TYPE=Release \
+	-DCMAKE_SKIP_RPATH=ON \
 	-DCMAKE_INSTALL_LIBDIR=share \
-	-DAMDGPU_TARGETS="gfx803;gfx900;gfx906;gfx908;gfx90a;gfx1010;gfx1030" \
+	-DAMDGPU_TARGETS="gfx803;gfx900;gfx906;gfx908;gfx90a;gfx1010;gfx1030;gfx1100;gfx1101;gfx1102" \
 	-DROCM_SYMLINK_LIBS=OFF \
 	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF
 
@@ -37,10 +39,12 @@
 override_dh_auto_test-indep:
 	:
 
+# dwz doesn't fully support DWARF-5 yet, see #1016936
+override_dh_dwz:
+	:
+
 execute_before_dh_install-arch:
-	# Note the rpath field setting may cause reproducible build issues.
-	# This should be removed earlier in the toolchain if possible.
-	patchelf --remove-rpath ./debian/tmp/usr/bin/test_*
+	:
 
 override_dh_auto_install-indep:
 	dh_auto_install --destdir=debian/tmp
