=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocprim-$1.tar.gz%" \
    https://github.com/rocm/rocprim/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
